// ======================================================================
//
// pal_3dfx.cpp
// jeff grills
//
// copyright 1998 origin systems inc
//
// ======================================================================

#include "first.h"
#include "PaletteData_3dfx.h"

#include "Gl_3dfx.h"
#include "Palette.h"

// ======================================================================

u_int PaletteData_3dfx::globalToken;
u_int PaletteData_3dfx::currentToken;

// ======================================================================

PaletteData_3dfx::PaletteData_3dfx(const Palette *pal)
{
	int        i;
	const RGB *rgb;

	entries = pal->getEntries();
	rgb = pal->getRGB();

	for (i = 0; i < entries; i++, rgb++)
		data[i] = (rgb->r << 16) | (rgb->g <<  8) | (rgb->b <<  0);

	token = ++globalToken;
}

// ----------------------------------------------------------------------

PaletteData_3dfx::~PaletteData_3dfx(void)
{
}

// ----------------------------------------------------------------------

void PaletteData_3dfx::download(void) const
{
	if (token != currentToken)
	{
		currentToken = token;
		GL_3dfx::countDownloadedPalette();
		grTexDownloadTablePartial(GR_TMU0, GR_TEXTABLE_PALETTE, const_cast<FxU32 *>(data), 0, entries-1);
	}
}


// ======================================================================
